﻿from tkinter import *
import math
def genCanvas(title="fuzzy", width=440,height=240,bg="white"):
    root=Tk(); root.title(title);root.attributes("-topmost", True)
    canvas=Canvas(root,width=width,height=height,bg=bg)
    canvas.pack(); return canvas
def drawScale(canvas):#■目盛り表示
    for i in range(11):# Y軸目盛り
        CL="#CCCCCC"
        if i % 5==0: CL="#777777"
        Y=i*20+20;CH="%3.1f" % (1-float(i)*0.1)
        canvas.create_line(30,Y,430,Y,fill=CL,width=1)
        canvas.create_text(15,Y,text=CH,font=("Times",8))
    for i in range(11):# X軸目盛り
        CL="#CCCCCC"
        if i % 5==0: CL="#777777"
        X=i*40+30;CH="%3.1f" % (float(i)*0.1)
        canvas.create_line(X,20,X,220,fill=CL,width=1)
        canvas.create_text(X,230,text=CH,font=("Times",8))
def drawGraph0(canvas,F,width=1,color="black"):#■グラフ表示基本処理
    X2=30; Y2=220-F[0]*200
    for i in range(1,101):
        X1=X2; Y1=Y2
        X2=30+i*4;Y2=220-F[i]*200
        canvas.create_line(X1,Y1,X2,Y2,fill=color,width=width)
def drawGraph1(canvas,F):#■１本のグラフ
    drawScale(canvas)
    drawGraph0(canvas,F,width=3,color="red")
def drawGraph2(canvas,F1,F2):#■２本のグラフ
    drawScale(canvas)
    drawGraph0(canvas,F1,width=3,color="blue")
    drawGraph0(canvas,F2,width=3,color="red")
def drawGraph3(canvas,F1,F2,F3):#■３本のグラフ
    drawScale(canvas)
    drawGraph0(canvas,F1,width=3,color="blue")
    drawGraph0(canvas,F2,width=3,color="green")
    drawGraph0(canvas,F3,width=3,color="red")
def drawGraph3X(canvas,F1,F2,F3):#■３本のグラフ
    drawScale(canvas)
    drawGraph0(canvas,F1,width=2,color="blue")
    drawGraph0(canvas,F2,width=2,color="green")
    drawGraph0(canvas,F3,width=4,color="red")

def setMiddle(Center,Grad):#■中程度（線形）
    DX=25/Grad
    return fuzzyNot(fuzzyOr(setHight(Center+DX,Grad),
                            setLow(Center-DX,Grad)))
def setHight(Center,Grad):#■高い（線形）
    F=[0.0 for i in range(101)]
    for i in range(101):
        Z=float((i-Center)*Grad)/50+0.5
        if Z>1:Z=1
        if Z<0:Z=0
        F[i]=Z
    return F
def setLow(Center,Grad):#■低い（線形）
    return fuzzyNot(setHight(Center,Grad))
def setGradHight(Center,Grad):#■高い（滑らか）
    F=[0.0 for i in range(101)]
    for i in range(101):
        X=float(i-Center)*0.075*Grad
        EP=math.exp(X); EM=math.exp(-X)
        F[i]=((EP-EM)/(EP+EM)+1)*0.5
    return F
def setGradMiddle():#■中程度（滑らか）
    FD=setGradHight(50,1)
    F=[0.0 for i in range(101)]
    for i in range(1,100):
        F[i]=(FD[i+1]-FD[i-1])
    MX=-999
    for i in range(101):
        if MX<F[i]:MX=F[i]
    for i in range(101):F[i]/=MX
    return F
def fuzzyNot(A):#■Not
    F=[0.0 for i in range(101)]
    for i in range(101): F[i]=1.0-A[i]
    return F
def fuzzyOr(A,B):#■Or
    F=[0.0 for i in range(101)]
    for i in range(101):
        if A[i]>B[i]:F[i]=A[i]
        else:        F[i]=B[i]
    return F
def fuzzyAnd(A,B):#■And
    F=[0.0 for i in range(101)]
    for i in range(101):
        if A[i]<B[i]:F[i]=A[i]
        else:        F[i]=B[i]
    return F

